#define _Test_h
#include <Ethernet.h>

//#if defined(ARDUINO) && ARDUINO >= 100
//    #include "Arduino.h"

//    #include <string.h> /* memcpy */
//    #include <stdlib.h> /* abs */
//    #include <wiringPi.h>
//#elif defined(SPARK)
//    #include "application.h"
//#else
//    #include "WProgram.h"
//#endif

#include <stdint.h>


#if defined( __AVR_ATtinyX5__ ) or defined ( __AVR_ATtinyX4__ )
#define TestDisableReceiving
#endif

#define Test_MAX_CHANGES 67

class Test {

  public:
    Test();
    void enableReceive(int16_t interrupt); 
    bool available();
    void callProcessing(); 


    void testVoid(byte a, int16_t b);
    bool testAsupB(byte a, byte b);
    char testChar(char a, char b, bool c);
    byte testByteSumAB(byte a, byte b);
    int16_t testIntSumAB(int16_t a, int16_t b);
    uint16_t testUintSumAB(uint16_t a, uint16_t b);
    int32_t testLongSumAB(int32_t a, int32_t b);
    uint32_t testUlongSumAB(uint32_t a, uint32_t b);
    float testFloatDivAbyB(float a, float b);
    double testDoubleDivAbyB(double a, double b);
    //test return in  Array types
    byte * testArrayByte(byte a, byte b);
    int16_t * testArrayInt(int16_t a, int16_t b);
    uint16_t * testArrayUint(uint16_t a, uint16_t b);
    int32_t * testArrayLong(int32_t a, int32_t b);
    uint32_t * testArrayUlong(uint32_t a, uint32_t b);
    float * testArrayFloat(float a, float b);
    double * testArrayDouble(double a, double b);       
    //test return in  string types         
    char * testB4RStringChar(void); 
    char * testB4RStringChar2(const char * a, const char * b); 
    String testB4RStringChar3(String a, String b); 
    char * testB4RStringChar4(String a, String b);
    IPAddress testIPAddress(IPAddress a);

    //B4X 1 ArrayByte => Wrapper => 1 byte* library Return 1 byte parameter => wrapper => B4X byte   
    byte testBytearray(byte* ab);
    int16_t testintarray(int16_t* ab);
    uint16_t testUintarray(uint16_t* ab);
    int32_t testlongarray(int32_t* ab);
    uint32_t testUlongarray(uint32_t* ab);
    float testfloatarray(float* ab);
    double testDoublearray(double* ab);  
    void testSizeOf(); 
    //variables modified by library and accessible by B4R programme    
    void ReadBytes(byte* a,uint16_t alen);               
    void ReadFloats(float* ax,float* ay, float* az);
    void ReadFloats2(float* ax,float* ay, float* az);    
  };  