    //#New(backend): Y                                                //- [Y]  if new (backend) to add
    //#Init_Base:    Test()                                                //- parameter to add at launch of library in case of backend
    //#Init_Include: void enableReceive(int16_t interrupt)                                                //- function added at initialization (it can be Loop_Base)
    //#Loop_Base:                                                    //- function launched at loop start and activation callback function on event
    //#Loop1_Event:  bool available()                                                //- event to monitor in a loop
    //#Loop1_Config: SubVoid_Void  -1 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop2_Event:                                                  //- event to monitor in a loop
    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop3_Event:                                                  //- event to monitor in a loop
    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#CallBack1_Base:                                               //- callback on arduino side
    //#CallBack1_Config: SubVoid_BArray 0 MessageArrivedSub          //- CallbackType Par1 EndPar callbacksub
    //#CallBack2_Base:                                               //- callback on arduino side
    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#CallBack3_Base:                                               //- callback on arduino side
    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#

#include "B4RDefines.h"

namespace B4R
{

    void B4RTest::Initialize(int16_t interrupt, SubVoid_Void DataAvailableSub)
    {
       rcs = new (backend) Test();
       this->DataAvailableSub = DataAvailableSub; 
       FunctionUnion fu; 
       fu.PollerFunction = looper;
       pnode.functionUnion = fu;
       pnode.tag = this; 
       if (pnode.next == NULL) 
          pollers.add(&pnode); 
       rcs->enableReceive(interrupt);
    };

    void B4RTest::looper(void* b) 
    {
       B4RTest* me = (B4RTest*)b;
       if (me->rcs->available()) { 
         me->DataAvailableSub();
         }
    };

//    Test()
//    void enableReceive(int16_t interrupt) 
//    bool available()
    void B4RTest::callProcessing()
    {
       rcs->callProcessing();
    };

    void B4RTest::testVoid(byte a, int16_t b)
    {
       rcs->testVoid(a, b);
    };

    bool B4RTest::testAsupB(byte a, byte b)
    {
       return rcs->testAsupB(a, b);
    };

    byte B4RTest::testChar(byte a, byte b, bool c)
    {
       return rcs->testChar(a, b, c);
    };

    byte B4RTest::testByteSumAB(byte a, byte b)
    {
       return rcs->testByteSumAB(a, b);
    };

    int16_t B4RTest::testIntSumAB(int16_t a, int16_t b)
    {
       return rcs->testIntSumAB(a, b);
    };

    uint16_t B4RTest::testUintSumAB(uint16_t a, uint16_t b)
    {
       return rcs->testUintSumAB(a, b);
    };

    int32_t B4RTest::testLongSumAB(int32_t a, int32_t b)
    {
       return rcs->testLongSumAB(a, b);
    };

    uint32_t B4RTest::testUlongSumAB(uint32_t a, uint32_t b)
    {
       return rcs->testUlongSumAB(a, b);
    };

    float B4RTest::testFloatDivAbyB(float a, float b)
    {
       return rcs->testFloatDivAbyB(a, b);
    };

    double B4RTest::testDoubleDivAbyB(double a, double b)
    {
       return rcs->testDoubleDivAbyB(a, b);
    };

    ArrayByte* B4RTest::testArrayByte(byte a, byte b)
    {
       byte* raw = rcs->testArrayByte(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayByte* arr = CreateStackMemoryObject(ArrayByte);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayInt* B4RTest::testArrayInt(int16_t a, int16_t b)
    {
       int16_t* raw = rcs->testArrayInt(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayInt* arr = CreateStackMemoryObject(ArrayInt);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayUInt* B4RTest::testArrayUint(uint16_t a, uint16_t b)
    {
       uint16_t* raw = rcs->testArrayUint(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayUInt* arr = CreateStackMemoryObject(ArrayUInt);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayLong* B4RTest::testArrayLong(int32_t a, int32_t b)
    {
       int32_t* raw = rcs->testArrayLong(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayLong* arr = CreateStackMemoryObject(ArrayLong);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayULong* B4RTest::testArrayUlong(uint32_t a, uint32_t b)
    {
       uint32_t* raw = rcs->testArrayUlong(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayULong* arr = CreateStackMemoryObject(ArrayULong);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayDouble* B4RTest::testArrayFloat(float a, float b)
    {
       float* raw = rcs->testArrayFloat(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayDouble* arr = CreateStackMemoryObject(ArrayDouble);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayDouble* B4RTest::testArrayDouble(double a, double b)
    {
       double* raw = rcs->testArrayDouble(a, b);
       union {byte array[4]; float arr; } Convert;
       uint16_t len = 3; //raw.size() or fixe value depending of the arduino part
       ArrayByte* arr = CreateStackMemoryObject(ArrayByte);
       arr->data = (StackMemory::buffer + StackMemory::cp);
       for (uint16_t i = 0;i < len; i++) { 
         Convert.arr = raw[i];
         for (uint16_t j = 0; j < 4; j++) {
         StackMemory::buffer[StackMemory::cp++] =Convert.array[j];
         }
       }
       arr->length=len;
       return arr;
    };

    B4RString* B4RTest::testB4RStringChar()
    {
       char* raw = rcs->testB4RStringChar();
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;
    };

    B4RString* B4RTest::testB4RStringChar2(B4RString* a, B4RString* b)
    {
       char* raw = rcs->testB4RStringChar2(a->data, b->data);
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;
    };

    B4RString* B4RTest::testB4RStringChar3(B4RString* a, B4RString* b)
    {
       String rax = rcs->testB4RStringChar3(a->data, b->data);
       PrintToMemory pm;
       B4RString* s = B4RString::PrintableToString(NULL);
       pm.print(rax);
       StackMemory::buffer[StackMemory::cp++] = 0;
       return s;
    };

    B4RString* B4RTest::testB4RStringChar4(B4RString* a, B4RString* b)
    {
       char* raw = rcs->testB4RStringChar4(a->data, b->data);
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;
    };

    B4RString* B4RTest::testIPAddress(ArrayByte* a)
    {
       IPAddress ip = rcs->testIPAddress((Byte*)a->data);
       return B4RString::PrintableToString(&ip);
    };

    byte B4RTest::testBytearray(ArrayByte* ab)
    {
       return rcs->testBytearray((byte*)ab->data);
    };

    int16_t B4RTest::testintarray(ArrayInt* ab)
    {
       return rcs->testintarray((int16_t*)ab->data);
    };

    uint16_t B4RTest::testUintarray(ArrayUInt* ab)
    {
       return rcs->testUintarray((uint16_t*)ab->data);
    };

    int32_t B4RTest::testlongarray(ArrayLong* ab)
    {
       return rcs->testlongarray((int32_t*)ab->data);
    };

    uint32_t B4RTest::testUlongarray(ArrayULong* ab)
    {
       return rcs->testUlongarray((uint32_t*)ab->data);
    };

    float B4RTest::testfloatarray(ArrayDouble* ab)
    {
       return rcs->testfloatarray((float*)ab->data);
    };

    double B4RTest::testDoublearray(ArrayDouble* ab)
    {
      float * a = (float*)ab->data;  double b[ab->length];
      for (uint16_t x=0; x<(ab->length); x++) {b[x] = (double)a[x];};
      return rcs->testDoublearray(b);       
//       return rcs->testDoublearray((double*)a);
    };

    void B4RTest::testSizeOf()
    {
       rcs->testSizeOf();
    };

    void B4RTest::ReadBytes(ArrayByte* a, uint16_t alen)
    {
       rcs->ReadBytes((byte*)a->data, alen);
    };

    ArrayDouble* B4RTest::ReadFloats()
    {
      float raw[3] ;
      rcs->ReadFloats(&raw[0],&raw[1],&raw[2]);  
       ArrayULong* arr = CreateStackMemoryObject(ArrayULong);
       arr->data=raw;
       arr->length=3;
       return arr;
     };

    void B4RTest::ReadFloats2(ArrayDouble* ab)
    {
      float * raw = (float*)ab->data;
      rcs->ReadFloats2(&raw[0],&raw[1],&raw[2]);  
      ab->data = raw;
     };
}
