    //#New(backend): Y                                                //- [Y]  if new (backend) to add
    //#Init_Base:    Test()                                                //- parameter to add at launch of library in case of backend
    //#Init_Include: void enableReceive(int16_t interrupt)                                                //- function added at initialization (it can be Loop_Base)
    //#Loop_Base:                                                    //- function launched at loop start and activation callback function on event
    //#Loop1_Event:  bool available()                                                //- event to monitor in a loop
    //#Loop1_Config: SubVoid_Void  -1 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop2_Event:                                                  //- event to monitor in a loop
    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop3_Event:                                                  //- event to monitor in a loop
    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#CallBack1_Base:                                               //- callback on arduino side
    //#CallBack1_Config: SubVoid_BArray 0 MessageArrivedSub          //- CallbackType Par1 EndPar callbacksub
    //#CallBack2_Base:                                               //- callback on arduino side
    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#CallBack3_Base:                                               //- callback on arduino side
    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#

#pragma once
#include "B4RDefines.h"
#include "Test.h"

    //~Event: DataAvailable()
    //~Version: 1.0 
    //~Author - 
    //~Libray from Arduino

namespace B4R {
    typedef void (*SubVoid_Void)(void);
    //~shortname:Test
    class B4RTest
    {
        private:
            uint8_t backend[sizeof(Test)];
            Test* rcs;
            PollerNode pnode;
            SubVoid_Void DataAvailableSub;
            static void looper(void* b);
//    Test()
//    void enableReceive(int16_t interrupt) 
//    bool available()
//       return rcs->testDoublearray((double*)a);
        public: 
            void Initialize(int16_t interrupt, SubVoid_Void DataAvailableSub);
            void callProcessing();
            void testVoid(byte a, int16_t b);
            bool testAsupB(byte a, byte b);
            byte testChar(byte a, byte b, bool c);
            byte testByteSumAB(byte a, byte b);
            int16_t testIntSumAB(int16_t a, int16_t b);
            uint16_t testUintSumAB(uint16_t a, uint16_t b);
            int32_t testLongSumAB(int32_t a, int32_t b);
            uint32_t testUlongSumAB(uint32_t a, uint32_t b);
            float testFloatDivAbyB(float a, float b);
            double testDoubleDivAbyB(double a, double b);
            ArrayByte* testArrayByte(byte a, byte b);
            ArrayInt* testArrayInt(int16_t a, int16_t b);
            ArrayUInt* testArrayUint(uint16_t a, uint16_t b);
            ArrayLong* testArrayLong(int32_t a, int32_t b);
            ArrayULong* testArrayUlong(uint32_t a, uint32_t b);
            ArrayDouble* testArrayFloat(float a, float b);
            ArrayDouble* testArrayDouble(double a, double b);
            B4RString* testB4RStringChar();
            B4RString* testB4RStringChar2(B4RString* a, B4RString* b);
            B4RString* testB4RStringChar3(B4RString* a, B4RString* b);
            B4RString* testB4RStringChar4(B4RString* a, B4RString* b);
            B4RString* testIPAddress(ArrayByte* a);
            byte testBytearray(ArrayByte* ab);
            int16_t testintarray(ArrayInt* ab);
            uint16_t testUintarray(ArrayUInt* ab);
            int32_t testlongarray(ArrayLong* ab);
            uint32_t testUlongarray(ArrayULong* ab);
            float testfloatarray(ArrayDouble* ab);
            double testDoublearray(ArrayDouble* ab);
            void testSizeOf();
            void ReadBytes(ArrayByte* a, uint16_t alen);
            ArrayDouble* ReadFloats();
            void ReadFloats2(ArrayDouble* ab) ;
    };
}
